# SARA'S C UTILITIES (C UTES)

A collection of utilities I keep copying around/reimplementing for various C projects.

## utilities:
- debug: some debug logging and assertion macros using stdio.
- typeclass_helpers: macros to help with typeclasses.
- mirror: a mirror typeclass that uses macros to enable casting typeclass instances to other typeclass instances.
- drop: a drop typeclass to destroy objects.
- variant: a variant struct, mainly useful in combination with dictionaries for (de-)serialization
- vmath: float and int vector math
- strutil: some string utilities
- list: a heap-allocated dynamically sized list.
- dictionary: a heap-allocated string-key hashmap.
